import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkUsersAddress, ThinkUsersAddressParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkUsersAddress(params: ThinkUsersAddressParam) {
  const res = await request.get<ApiResult<PageResult<ThinkUsersAddress>>>(
    THINK_API_URL + '/think/think-users-address/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkUsersAddress(params?: ThinkUsersAddressParam) {
  const res = await request.get<ApiResult<ThinkUsersAddress[]>>(
    THINK_API_URL + '/think/think-users-address',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkUsersAddress(data: ThinkUsersAddress) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-address',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkUsersAddress(data: ThinkUsersAddress) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-address',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkUsersAddress(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-address/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkUsersAddress(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-address/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkUsersAddress(id: number) {
  const res = await request.get<ApiResult<ThinkUsersAddress>>(
    THINK_API_URL + '/think/think-users-address/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
